diff --git a/src/zabbix_server/vmware/vmware.c b/src/zabbix_server/vmware/vmware.c
index 43dd9835e99..3379b506ac1 100644
--- a/src/zabbix_server/vmware/vmware.c
+++ b/src/zabbix_server/vmware/vmware.c
@@ -5372,6 +5968,41 @@ clean:
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s() found:%d", __func__, i);
 }
 
+/******************************************************************************
+ *                                                                            *
+ * Function: vmware_hv_vsan_uuid                                              *
+ *                                                                            *
+ * Purpose: search for Datastore uuid with type equal to 'vsan'               *
+ *                                                                            *
+ * Parameters: dss    - [IN] the vector with all Datastores                   *
+ *             hv_dss - [IN] the vector with all Datastores attechad to HV    *
+ *                                                                            *
+ * Return value: pointer to vsan DS uuid or NULL                              *
+ *                                                                            *
+ ******************************************************************************/
+static const char	*vmware_hv_vsan_uuid(zbx_vector_vmware_datastore_t *dss, zbx_vector_str_t *hv_dss)
+{
+	int	i;
+
+	for (i = 0; i < hv_dss->values_num; i++)
+	{
+		int			j;
+		zbx_vmware_datastore_t	*ds, ds_cmp;
+
+		ds_cmp.id = hv_dss->values[i];
+
+		if (FAIL == (j = zbx_vector_vmware_datastore_bsearch(dss, &ds_cmp, vmware_ds_id_compare)))
+			continue;
+
+		ds = dss->values[j];
+
+		if ('v' == *ds->type && 0 == strcmp("vsan", ds->type))	/* only one vsan can be attached to HV */
+			return ds->uuid;
+	}
+
+	return NULL;
+}
+
 /******************************************************************************
  *                                                                            *
  * Purpose: sorting function to sort Resource pool names vector by name       *
@@ -5410,30 +6041,36 @@ static int	vmware_service_init_hv(zbx_vmware_service_t *service, CURL *easyhandl
 		zbx_vector_cq_value_t *cq_values, zbx_vmware_alarms_data_t *alarms_data, zbx_vmware_hv_t *hv,
 		char **error)
 {
-	char				*value, buff[MAX_STRING_LEN];
+	char				*value, *cq_prop;
+	int				i, j, ret;
 	xmlDoc				*details = NULL, *multipath_data = NULL;
 	zbx_vector_str_t		datastores, vms;
-	zbx_vmware_cq_value_t		*cqv;
-	int				i, j, ret = FAIL;
+	zbx_vector_cq_value_t		cqvs;
+	zbx_vector_ptr_pair_t		disks_info;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() hvid:'%s'", __func__, id);
 
 	memset(hv, 0, sizeof(zbx_vmware_hv_t));
 
 	zbx_vector_vmware_dsname_create(&hv->dsnames);
+	zbx_vector_vmware_diskinfo_create(&hv->diskinfo);
 	zbx_vector_ptr_create(&hv->vms);
 
 	zbx_vector_str_create(&datastores);
 	zbx_vector_str_create(&vms);
+	zbx_vector_ptr_pair_create(&disks_info);
+	zbx_vector_cq_value_create(&cqvs);
 
 	zbx_vector_vmware_pnic_create(&hv->pnics);
+	cq_prop = vmware_cq_prop_soap_request(cq_values, ZBX_VMWARE_SOAP_HV, id, &cqvs);
+	ret = vmware_service_get_hv_data(service, easyhandle, id, hv_propmap, ZBX_VMWARE_HVPROPS_NUM, cq_prop,
+			&details, error);
+	zbx_str_free(cq_prop);
 
-	if (SUCCEED != vmware_service_get_hv_data(service, easyhandle, id, hv_propmap, ZBX_VMWARE_HVPROPS_NUM,
-			vmware_cq_prop_soap_request(cq_values, ZBX_VMWARE_SOAP_HV, id, sizeof(buff), buff, &cqv),
-			&details, error))
-	{
+	if (FAIL == ret)
 		goto out;
-	}
+
+	ret = FAIL;
 
 	if (NULL == (hv->props = xml_read_props(details, hv_propmap, ZBX_VMWARE_HVPROPS_NUM)))
 		goto out;
@@ -5446,16 +6083,21 @@ static int	vmware_service_init_hv(zbx_vmware_service_t *service, CURL *easyhandl
 
 	vmware_service_get_hv_pnics_data(details, &hv->pnics);
 	zbx_vector_str_create(&hv->alarm_ids);
-	vmware_service_get_alarms_data(__func__, service, easyhandle, details, NULL, &hv->alarm_ids, alarms_data,
-			error);
+
+	if (FAIL == vmware_service_get_alarms_data(__func__, service, easyhandle, details, NULL, &hv->alarm_ids,
+			alarms_data, error))
+	{
+		zabbix_log(LOG_LEVEL_WARNING, "Cannot get hv %s alarms: %s.", hv->id, *error);
+		zbx_str_free(*error);
+	}
 
 	if (NULL != (value = zbx_xml_doc_read_value(details, "//*[@type='" ZBX_VMWARE_SOAP_CLUSTER "']")))
 		hv->clusterid = value;
 
 	hv->ip = vmware_hv_ip_search(details);
 
-	if (NULL != cqv)
-		vmware_service_cq_prop_value(__func__, details, cqv);
+	if (0 != cqvs.values_num)
+		vmware_service_cq_prop_value(__func__, details, &cqvs);
 
 	if (SUCCEED != vmware_hv_get_parent_data(service, easyhandle, hv, error))
 		goto out;
@@ -5469,6 +6111,12 @@ static int	vmware_service_init_hv(zbx_vmware_service_t *service, CURL *easyhandl
 	if (SUCCEED != vmware_service_hv_get_multipath_data(service, easyhandle, details, id, &multipath_data, error))
 		goto out;
 
+	if (SUCCEED != vmware_service_hv_disks_get_info(service, easyhandle, details, id, dss,
+			vmware_hv_vsan_uuid(dss, &datastores), &disks_info, error))
+	{
+		goto out;
+	}
+
 	if (SUCCEED != vmware_hv_ds_access_update(service, easyhandle, hv->uuid, hv->id, &datastores, dss, error))
 		goto out;
 
@@ -5498,17 +6146,23 @@ static int	vmware_service_init_hv(zbx_vmware_service_t *service, CURL *easyhandl
 		{
 			zbx_vmware_diskextent_t	*diskextent = ds->diskextents.values[j];
 			zbx_vmware_hvdisk_t	hvdisk;
-			char			tmp[MAX_STRING_LEN], *lun;
+			zbx_vmware_diskinfo_t	di;
+			zbx_ptr_pair_t		pair_cmp = {.second = &di};
+			const char		*lun;
+			char			tmp[MAX_STRING_LEN];
+			int			k;
 
-			zbx_snprintf(tmp, sizeof(tmp), ZBX_XPATH_HV_LUN(), diskextent->diskname);
+			di.diskname = diskextent->diskname;
 
-			if (NULL == (lun = zbx_xml_doc_read_value(multipath_data, tmp)))
+			if (FAIL == (k = zbx_vector_ptr_pair_bsearch(&disks_info, pair_cmp,
+					vmware_diskinfo_diskname_compare)))
 			{
 				zabbix_log(LOG_LEVEL_DEBUG, "%s(): not found diskextent: %s",
 						__func__, diskextent->diskname);
 				continue;
 			}
 
+			lun = (const char*)disks_info.values[k].first;
 			zbx_snprintf(tmp, sizeof(tmp), ZBX_XPATH_HV_MULTIPATH_PATHS(), lun);
 
 			if (SUCCEED != zbx_xml_doc_read_num(multipath_data, tmp, &hvdisk.multipath_total) ||
@@ -5516,7 +6170,6 @@ static int	vmware_service_init_hv(zbx_vmware_service_t *service, CURL *easyhandl
 			{
 				zabbix_log(LOG_LEVEL_DEBUG, "%s(): for diskextent: %s and lun: %s"
 						" multipath data is not found", __func__, diskextent->diskname, lun);
-				zbx_free(lun);
 				continue;
 			}
 
@@ -5527,7 +6180,6 @@ static int	vmware_service_init_hv(zbx_vmware_service_t *service, CURL *easyhandl
 
 			hvdisk.partitionid = diskextent->partitionid;
 			zbx_vector_vmware_hvdisk_append(&dsname->hvdisks, hvdisk);
-			zbx_free(lun);
 		}
 
 		zbx_vector_vmware_hvdisk_sort(&dsname->hvdisks, ZBX_DEFAULT_UINT64_COMPARE_FUNC);
@@ -5552,7 +6204,14 @@ static int	vmware_service_init_hv(zbx_vmware_service_t *service, CURL *easyhandl
 			zabbix_log(LOG_LEVEL_DEBUG, "Unable initialize vm %s: %s.", vms.values[i], *error);
 			zbx_free(*error);
 		}
+	}
+
+	zbx_vector_vmware_diskinfo_reserve(&hv->diskinfo, (size_t)disks_info.values_num);
 
+	for (i = 0; i < disks_info.values_num; i++)
+	{
+		zbx_vector_vmware_diskinfo_append(&hv->diskinfo, disks_info.values[i].second);
+		disks_info.values[i].second = NULL;
 	}
 
 	ret = SUCCEED;
@@ -5565,6 +6224,17 @@ out:
 
 	zbx_vector_str_clear_ext(&datastores, zbx_str_free);
 	zbx_vector_str_destroy(&datastores);
+	zbx_vector_cq_value_destroy(&cqvs);
+
+	for (i = 0; i < disks_info.values_num; i++)
+	{
+		zbx_str_free(disks_info.values[i].first);
+
+		if (NULL != disks_info.values[i].second)
+			vmware_diskinfo_free((zbx_vmware_diskinfo_t *)disks_info.values[i].second);
+	}
+
+	zbx_vector_ptr_pair_destroy(&disks_info);
 
 	if (SUCCEED != ret)
 		vmware_hv_clean(hv);
@@ -5641,7 +6311,8 @@ static int	vmware_service_get_datacenters_list(const zbx_vmware_service_t *servi
 				nodeset->nodeTab[i], ZBX_XPATH_PROP_NAME_NODE("triggeredAlarmState")),
 				&datacenter->alarm_ids, alarms_data, &error))
 		{
-			zabbix_log(LOG_LEVEL_DEBUG, "%s(): Cannot get datacenter alarms: %s.", __func__, error);
+			zabbix_log(LOG_LEVEL_DEBUG, "%s(): Cannot get datacenter %s alarms: %s.", __func__,
+					datacenter->id, error);
 			zbx_str_free(error);
 		}
 
@@ -5916,6 +6587,7 @@ static int	vmware_service_get_hv_ds_dc_dvs_list(const zbx_vmware_service_t *serv
 		ZBX_XPATH_PROP_NAME_NODE("triggeredAlarmState")
 
 	char				tmp[MAX_STRING_LEN * 2];
+	const char			*pcollector = vmware_service_objects[service->type].property_collector;
 	int				ret = FAIL;
 	xmlDoc				*doc = NULL;
 	xmlNode				*vc_alarms;
@@ -5923,21 +6595,18 @@ static int	vmware_service_get_hv_ds_dc_dvs_list(const zbx_vmware_service_t *serv
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __func__);
 
-	zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_VCENTER_HV_DS_LIST,
-			vmware_service_objects[service->type].property_collector,
+	zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_VCENTER_HV_DS_LIST, pcollector,
 			vmware_service_objects[service->type].root_folder);
 
-	if (SUCCEED != zbx_property_collection_init(easyhandle, tmp, "propertyCollector", &iter, &doc, error))
-	{
+	if (SUCCEED != zbx_property_collection_init(easyhandle, tmp, pcollector, &iter, &doc, error))
 		goto out;
-	}
 
 	if (ZBX_VMWARE_TYPE_VCENTER == service->type)
-		zbx_xml_read_values(doc, "//*[@type='HostSystem']", hvs);
+		zbx_xml_read_values(doc, ZBX_XPATH_OBJS_BY_TYPE(ZBX_VMWARE_SOAP_HV) , hvs);
 	else
 		zbx_vector_str_append(hvs, zbx_strdup(NULL, "ha-host"));
 
-	zbx_xml_read_values(doc, "//*[@type='Datastore']", dss);
+	zbx_xml_read_values(doc, ZBX_XPATH_OBJS_BY_TYPE(ZBX_VMWARE_SOAP_DS), dss);
 	vmware_service_get_datacenters_list(service, easyhandle, doc, alarms_data, datacenters);
 	vmware_service_get_dvswitch_list(doc, dvswitches);
 	zbx_snprintf(tmp, sizeof(tmp), ZBX_XPATH_GET_ROOT_ALARMS(ZBX_VMWARE_SOAP_FOLDER, "%s"),
@@ -5958,9 +6627,9 @@ static int	vmware_service_get_hv_ds_dc_dvs_list(const zbx_vmware_service_t *serv
 			goto out;
 
 		if (ZBX_VMWARE_TYPE_VCENTER == service->type)
-			zbx_xml_read_values(doc, "//*[@type='HostSystem']", hvs);
+			zbx_xml_read_values(doc, ZBX_XPATH_OBJS_BY_TYPE(ZBX_VMWARE_SOAP_HV), hvs);
 
-		zbx_xml_read_values(doc, "//*[@type='Datastore']", dss);
+		zbx_xml_read_values(doc, ZBX_XPATH_OBJS_BY_TYPE(ZBX_VMWARE_SOAP_DS), dss);
 		vmware_service_get_datacenters_list(service, easyhandle, doc, alarms_data, datacenters);
 		vmware_service_get_dvswitch_list(doc, dvswitches);
 
@@ -6246,7 +6915,8 @@ static int	vmware_service_put_event_data(zbx_vector_ptr_t *events, zbx_id_xmlnod
 {
 	zbx_vmware_event_t		*event = NULL;
 	char				*message, *time_str, *ip;
-	int				timestamp = 0, nodes_det = 0;
+	int				nodes_det = 0;
+	time_t				timestamp = 0;
 	unsigned int			i;
 	zbx_uint64_t			sz;
 	static event_hostinfo_node_t	host_nodes[] =
@@ -6314,21 +6984,11 @@ static int	vmware_service_put_event_data(zbx_vector_ptr_t *events, zbx_id_xmlnod
 	}
 	else
 	{
-		int	year, mon, mday, hour, min, sec, t;
-
-		/* 2013-06-04T14:19:23.406298Z */
-		if (6 != sscanf(time_str, "%d-%d-%dT%d:%d:%d.%*s", &year, &mon, &mday, &hour, &min, &sec))
-		{
-			zabbix_log(LOG_LEVEL_TRACE, "unexpected format of createdTime '%s' for event"
-					" key '" ZBX_FS_UI64 "'", time_str, xml_event.id);
-		}
-		else if (SUCCEED != zbx_utc_time(year, mon, mday, hour, min, sec, &t))
+		if (FAIL == zbx_iso8601_utc(time_str, &timestamp))	/* 2013-06-04T14:19:23.406298Z */
 		{
-			zabbix_log(LOG_LEVEL_TRACE, "cannot convert createdTime '%s' for event key '"
+			zabbix_log(LOG_LEVEL_TRACE, "unexpected format of createdTime '%s' for event key '"
 					ZBX_FS_UI64 "'", time_str, xml_event.id);
 		}
-		else
-			timestamp = t;
 
 		zbx_free(time_str);
 	}
@@ -6881,16 +7541,19 @@ out:
  *                                                                            *
  * Parameters: easyhandle   - [IN] the CURL handle                            *
  *             clusterid    - [IN] the cluster id                             *
+ *             datastores   - [IN] all available Datastores                   *
  *             cq_values    - [IN/OUT] the vector with custom query entries   *
  *             status       - [OUT] a pointer to the output variable          *
+ *             dss          - [OUT] a list of DS available for cluster        *
  *             error        - [OUT] the error message in the case of failure  *
  *                                                                            *
  * Return value: SUCCEED - the operation has completed successfully           *
  *               FAIL    - the operation has failed                           *
  *                                                                            *
  ******************************************************************************/
-static int	vmware_service_get_cluster_status(CURL *easyhandle, const char *clusterid,
-		zbx_vector_cq_value_t *cq_values, char **status, char **error)
+static int	vmware_service_get_cluster_state(CURL *easyhandle, const char *clusterid,
+		const zbx_vector_vmware_datastore_t *datastores, zbx_vector_cq_value_t *cq_values, char **status,
+		zbx_vector_str_t *dss, char **error)
 {
 #	define ZBX_POST_VMWARE_CLUSTER_STATUS 								\
 		ZBX_POST_VSPHERE_HEADER									\
@@ -6901,6 +7564,7 @@ static int	vmware_service_get_cluster_status(CURL *easyhandle, const char *clust
 					"<ns0:type>ClusterComputeResource</ns0:type>"			\
 					"<ns0:all>false</ns0:all>"					\
 					"<ns0:pathSet>summary.overallStatus</ns0:pathSet>"		\
+					"<ns0:pathSet>datastore</ns0:pathSet>"				\
 					"%s"								\
 				"</ns0:propSet>"							\
 				"<ns0:objectSet>"							\
@@ -6911,32 +7575,56 @@ static int	vmware_service_get_cluster_status(CURL *easyhandle, const char *clust
 		"</ns0:RetrievePropertiesEx>"								\
 		ZBX_POST_VSPHERE_FOOTER
 
-	char			tmp[MAX_STRING_LEN], *clusterid_esc, buff[MAX_STRING_LEN];
-	int			ret = FAIL;
+	char			*tmp, *clusterid_esc, *cq_prop;
+	int			i, ret = FAIL;
 	xmlDoc			*doc = NULL;
-	zbx_vmware_cq_value_t	*cqv;
-
+	zbx_vector_cq_value_t	cqvs;
+	zbx_vector_str_t	ids;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() clusterid:'%s'", __func__, clusterid);
 
+	zbx_vector_str_create(&ids);
+	zbx_vector_cq_value_create(&cqvs);
 	clusterid_esc = zbx_xml_escape_dyn(clusterid);
+	cq_prop = vmware_cq_prop_soap_request(cq_values, ZBX_VMWARE_SOAP_CLUSTER, clusterid, &cqvs);
 
-	zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_VMWARE_CLUSTER_STATUS,
-			vmware_cq_prop_soap_request(cq_values, ZBX_VMWARE_SOAP_CLUSTER, clusterid, sizeof(buff), buff,
-			&cqv), clusterid_esc);
+	tmp = zbx_dsprintf(NULL, ZBX_POST_VMWARE_CLUSTER_STATUS, cq_prop, clusterid_esc);
 
-	zbx_free(clusterid_esc);
+	zbx_str_free(cq_prop);
+	zbx_str_free(clusterid_esc);
+	ret = zbx_soap_post(__func__, easyhandle, tmp, &doc, NULL, error);
+	zbx_str_free(tmp);
 
-	if (SUCCEED != zbx_soap_post(__func__, easyhandle, tmp, &doc, NULL, error))
+	if (FAIL == ret)
 		goto out;
 
 	*status = zbx_xml_doc_read_value(doc, ZBX_XPATH_PROP_NAME("summary.overallStatus"));
 
-	if (NULL != cqv)
-		vmware_service_cq_prop_value(__func__, doc, cqv);
+	if (0 != cqvs.values_num)
+		vmware_service_cq_prop_value(__func__, doc, &cqvs);
 
-	ret = SUCCEED;
+	zbx_xml_read_values(doc, ZBX_XPATH_PROP_NAME("datastore") "/*", &ids);
+
+	for (i = 0; i < ids.values_num; i++)
+	{
+		int			j;
+		zbx_vmware_datastore_t	ds_cmp;
+
+		ds_cmp.id = ids.values[i];
+
+		if (FAIL == (j = zbx_vector_vmware_datastore_bsearch(datastores, &ds_cmp, vmware_ds_id_compare)))
+		{
+			zabbix_log(LOG_LEVEL_DEBUG, "%s(): Datastore \"%s\" not found on cluster \"%s\".", __func__,
+					ds_cmp.id, clusterid);
+			continue;
+		}
+
+		zbx_vector_str_append(dss, zbx_strdup(NULL, datastores->values[j]->uuid));
+	}
 out:
+	zbx_vector_cq_value_destroy(&cqvs);
+	zbx_vector_str_clear_ext(&ids, zbx_str_free);
+	zbx_vector_str_destroy(&ids);
 	zbx_xml_free_doc(doc);
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s", __func__, zbx_result_string(ret));
 
@@ -6951,6 +7639,7 @@ out:
  *                                                                            *
  * Parameters: service       - [IN] the vmware service                        *
  *             easyhandle    - [IN] the CURL handle                           *
+ *             datastores    - [IN] all available Datastores                  *
  *             cq_values     - [IN/OUT] the vector with custom query entries  *
  *             clusters      - [OUT] a pointer to the resulting clusters      *
  *                              vector                                        *
@@ -6964,38 +7653,39 @@ out:
  *                                                                            *
  ******************************************************************************/
 static int	vmware_service_get_clusters_and_resourcepools(zbx_vmware_service_t *service, CURL *easyhandle,
-		zbx_vector_cq_value_t *cq_values, zbx_vector_ptr_t *clusters,
-		zbx_vector_vmware_resourcepool_t *resourcepools, zbx_vmware_alarms_data_t *alarms_data, char **error)
+		const zbx_vector_vmware_datastore_t *datastores, zbx_vector_cq_value_t *cq_values,
+		zbx_vector_ptr_t *clusters, zbx_vector_vmware_resourcepool_t *resourcepools,
+		zbx_vmware_alarms_data_t *alarms_data, char **error)
 {
 	char			xpath[MAX_STRING_LEN];
 	int			i, ret = FAIL;
 	xmlDoc			*cluster_data = NULL;
-	zbx_vector_str_t	ids, rpools_all, rpools_uniq;
+	zbx_vector_str_t	ids, rpools_all, rpools_uniq, dss;
 	zbx_vmware_cluster_t	*cluster;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __func__);
 
 	zbx_vector_str_create(&ids);
+	zbx_vector_str_create(&dss);
 
 	if (SUCCEED != vmware_service_get_cluster_data(easyhandle, &cluster_data, error))
 		goto out;
 
-	zbx_xml_read_values(cluster_data, "/*/*/*/*/*[local-name()='objects']/*[local-name()='obj']"
-			"[@type='" ZBX_VMWARE_SOAP_CLUSTER "']", &ids);
+	zbx_xml_read_values(cluster_data, ZBX_XPATH_OBJS_BY_TYPE(ZBX_VMWARE_SOAP_CLUSTER), &ids);
 	zbx_vector_ptr_reserve(clusters, (size_t)(ids.values_num + clusters->values_alloc));
 
 	for (i = 0; i < ids.values_num; i++)
 	{
 		char	*status, *name;
 
-		zbx_snprintf(xpath, sizeof(xpath), "/*/*/*/*/*[local-name()='objects'][*[local-name()='obj']"
-				"[@type='" ZBX_VMWARE_SOAP_CLUSTER "'][.='%s']]/" ZBX_XPATH_PROP_NAME_NODE("name"),
-				ids.values[i]);
+		zbx_snprintf(xpath, sizeof(xpath), ZBX_XPATH_PROP_OBJECT_ID(ZBX_VMWARE_SOAP_CLUSTER, "[text()='%s']")
+				"/" ZBX_XPATH_PROP_NAME_NODE("name"), ids.values[i]);
 
 		if (NULL == (name = zbx_xml_doc_read_value(cluster_data, xpath)))
 			continue;
 
-		if (SUCCEED != vmware_service_get_cluster_status(easyhandle, ids.values[i], cq_values, &status, error))
+		if (SUCCEED != vmware_service_get_cluster_state(easyhandle, ids.values[i], datastores, cq_values,
+				&status, &dss, error))
 		{
 			zbx_free(name);
 			goto out;
@@ -7005,6 +7695,9 @@ static int	vmware_service_get_clusters_and_resourcepools(zbx_vmware_service_t *s
 		cluster->id = zbx_strdup(NULL, ids.values[i]);
 		cluster->name = name;
 		cluster->status = status;
+		zbx_vector_str_create(&cluster->dss_uuid);
+		zbx_vector_str_append_array(&cluster->dss_uuid, dss.values, dss.values_num);
+		zbx_vector_str_clear(&dss);
 		zbx_vector_str_create(&cluster->alarm_ids);
 
 		if (FAIL == vmware_service_get_alarms_data(__func__, service, easyhandle, cluster_data, NULL,
@@ -7057,6 +7750,7 @@ out:
 	zbx_xml_free_doc(cluster_data);
 	zbx_vector_str_clear_ext(&ids, zbx_str_free);
 	zbx_vector_str_destroy(&ids);
+	zbx_vector_str_destroy(&dss);
 
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s found cl:%d rp:%d", __func__, zbx_result_string(ret),
 			clusters->values_num, resourcepools->values_num);
@@ -7168,15 +7862,18 @@ out:
  * Parameters: counters  - [IN/OUT] the vector the created performance        *
  *                                  counter object should be added to         *
  *             counterid - [IN] the performance counter id                    *
+ *             state     - [IN] the performance counter first state           *
  *                                                                            *
  ******************************************************************************/
-static void	vmware_counters_add_new(zbx_vector_ptr_t *counters, zbx_uint64_t counterid)
+static void	vmware_counters_add_new(zbx_vector_ptr_t *counters, zbx_uint64_t counterid, unsigned char state)
 {
 	zbx_vmware_perf_counter_t	*counter;
 
 	counter = (zbx_vmware_perf_counter_t *)__vm_shmem_malloc_func(NULL, sizeof(zbx_vmware_perf_counter_t));
 	counter->counterid = counterid;
-	counter->state = ZBX_VMWARE_COUNTER_NEW;
+	counter->state = state;
+	counter->last_used = 0;
+	counter->query_instance = NULL;
 
 	zbx_vector_str_uint64_pair_create_ext(&counter->values, __vm_shmem_malloc_func, __vm_shmem_realloc_func,
 			__vm_shmem_free_func);
@@ -7204,7 +7901,7 @@ static int	vmware_service_initialize(zbx_vmware_service_t *service, CURL *easyha
 {
 #	define UNPARSED_SERVICE_MAJOR_VERSION_DELIM	"."
 
-	char			*version_without_major, *version = NULL, *fullname = NULL;
+	char			*subversion, *version = NULL, *fullname = NULL;
 	zbx_vector_ptr_t	counters;
 	int			ret = FAIL;
 
@@ -7263,14 +7960,23 @@ static int	vmware_service_initialize(zbx_vmware_service_t *service, CURL *easyha
 
 	/* version should have the "x.y.z" format, but there is also an "x.y Un" format in nature */
 	/* according to https://www.vmware.com/support/policies/version.html */
-	if (NULL == (version_without_major = strstr(version, UNPARSED_SERVICE_MAJOR_VERSION_DELIM)))
+	if (NULL == (subversion = strstr(version, UNPARSED_SERVICE_MAJOR_VERSION_DELIM)))
 	{
 		*error = zbx_dsprintf(*error, "Invalid version: %s.", version);
 		goto unlock;
 	}
 
 	service->minor_version = (unsigned short)atoi(
-			strlen(UNPARSED_SERVICE_MAJOR_VERSION_DELIM) + version_without_major);
+			ZBX_CONST_STRLEN(UNPARSED_SERVICE_MAJOR_VERSION_DELIM) + subversion);
+
+	if (NULL != (subversion = strstr(ZBX_CONST_STRLEN(UNPARSED_SERVICE_MAJOR_VERSION_DELIM) + subversion,
+			UNPARSED_SERVICE_MAJOR_VERSION_DELIM)))
+	{
+		service->patch_version = (unsigned short)atoi(
+				ZBX_CONST_STRLEN(UNPARSED_SERVICE_MAJOR_VERSION_DELIM) + subversion);
+	}
+	else
+		service->patch_version = 0;
 
 	ret = SUCCEED;
 unlock:
@@ -7303,7 +8009,7 @@ out:
  *                                                                            *
  ******************************************************************************/
 static void	vmware_service_add_perf_entity(zbx_vmware_service_t *service, const char *type, const char *id,
-		const char **counters, const char *instance, int now)
+		const char **counters, const char *instance, time_t now)
 {
 	zbx_vmware_perf_entity_t	entity, *pentity;
 	zbx_uint64_t			counterid;
@@ -7324,7 +8030,7 @@ static void	vmware_service_add_perf_entity(zbx_vmware_service_t *service, const
 		for (i = 0; NULL != counters[i]; i++)
 		{
 			if (SUCCEED == zbx_vmware_service_get_counterid(service, counters[i], &counterid, NULL))
-				vmware_counters_add_new(&pentity->counters, counterid);
+				vmware_counters_add_new(&pentity->counters, counterid, ZBX_VMWARE_COUNTER_NEW);
 			else
 				zabbix_log(LOG_LEVEL_DEBUG, "cannot find performance counter %s", counters[i]);
 		}
@@ -7398,14 +8104,14 @@ static void	vmware_service_update_perf_entities(zbx_vmware_service_t *service)
 	zbx_hashset_iter_reset(&service->data->hvs, &iter);
 	while (NULL != (hv = (zbx_vmware_hv_t *)zbx_hashset_iter_next(&iter)))
 	{
-		vmware_service_add_perf_entity(service, ZBX_VMWARE_SOAP_HV, hv->id, hv_perfcounters, "*",
-				service->lastcheck);
+		vmware_service_add_perf_entity(service, ZBX_VMWARE_SOAP_HV, hv->id, hv_perfcounters,
+				ZBX_VMWARE_PERF_QUERY_ALL, service->lastcheck);
 
 		for (i = 0; i < hv->vms.values_num; i++)
 		{
 			vm = (zbx_vmware_vm_t *)hv->vms.values[i];
-			vmware_service_add_perf_entity(service, ZBX_VMWARE_SOAP_VM, vm->id, vm_perfcounters, "*",
-					service->lastcheck);
+			vmware_service_add_perf_entity(service, ZBX_VMWARE_SOAP_VM, vm->id, vm_perfcounters,
+					ZBX_VMWARE_PERF_QUERY_ALL, service->lastcheck);
 			zabbix_log(LOG_LEVEL_TRACE, "%s() for type: VirtualMachine hv id: %s hv uuid: %s linked vm id:"
 					" %s vm uuid: %s", __func__, hv->id, hv->uuid, vm->id, vm->uuid);
 		}
@@ -7416,8 +8122,8 @@ static void	vmware_service_update_perf_entities(zbx_vmware_service_t *service)
 		for (i = 0; i < service->data->datastores.values_num; i++)
 		{
 			zbx_vmware_datastore_t	*ds = service->data->datastores.values[i];
-			vmware_service_add_perf_entity(service, ZBX_VMWARE_SOAP_DS, ds->id, ds_perfcounters, "",
-					service->lastcheck);
+			vmware_service_add_perf_entity(service, ZBX_VMWARE_SOAP_DS, ds->id, ds_perfcounters,
+					ZBX_VMWARE_PERF_QUERY_TOTAL, service->lastcheck);
 			zabbix_log(LOG_LEVEL_TRACE, "%s() for type: Datastore id: %s name: %s uuid: %s", __func__,
 					ds->id, ds->name, ds->uuid);
 		}
@@ -7440,18 +8146,18 @@ static void	vmware_service_copy_cust_query_response(zbx_vector_cq_value_t *cq_va
 
 	for (i = 0; i < cq_values->values_num; i++)
 	{
-		if (ZBX_VMWARE_CQV_ERROR == cq_values->values[i].status)
+		if (ZBX_VMWARE_CQV_ERROR == cq_values->values[i]->status)
 		{
-			vmware_shared_strfree(cq_values->values[i].instance->error);
-			cq_values->values[i].instance->error = vmware_shared_strdup(cq_values->values[i].response);
-			cq_values->values[i].instance->state = ZBX_VMWARE_CQ_ERROR | ZBX_VMWARE_CQ_SEPARATE;
+			vmware_shared_strfree(cq_values->values[i]->instance->error);
+			cq_values->values[i]->instance->error = vmware_shared_strdup(cq_values->values[i]->response);
+			cq_values->values[i]->instance->state = ZBX_VMWARE_CQ_ERROR | ZBX_VMWARE_CQ_SEPARATE;
 		}
-		else if (ZBX_VMWARE_CQV_VALUE == cq_values->values[i].status)
+		else if (ZBX_VMWARE_CQV_VALUE == cq_values->values[i]->status)
 		{
-			vmware_shared_strfree(cq_values->values[i].instance->value);
-			cq_values->values[i].instance->value = vmware_shared_strdup(cq_values->values[i].response);
-			cq_values->values[i].instance->state = (unsigned char)(ZBX_VMWARE_CQ_READY |
-					(cq_values->values[i].instance->state & ZBX_VMWARE_CQ_SEPARATE));
+			vmware_shared_strfree(cq_values->values[i]->instance->value);
+			cq_values->values[i]->instance->value = vmware_shared_strdup(cq_values->values[i]->response);
+			cq_values->values[i]->instance->state = (unsigned char)(ZBX_VMWARE_CQ_READY |
+					(cq_values->values[i]->instance->state & ZBX_VMWARE_CQ_SEPARATE));
 		}
 	}
 }
@@ -7473,16 +8179,18 @@ static void	vmware_service_cust_query_prep(zbx_hashset_t *cust_queries, const zb
 	zbx_vmware_cust_query_t	*instance;
 	time_t			now = time(NULL);
 
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s() cust_queries:%d", __func__, cust_queries->num_data);
+
 	zbx_hashset_iter_reset(cust_queries, &iter);
 
 	while (NULL != (instance = (zbx_vmware_cust_query_t *)zbx_hashset_iter_next(&iter)))
 	{
-		zbx_vmware_cq_value_t	cqv = {NULL, ZBX_VMWARE_CQV_EMPTY, NULL};
+		zbx_vmware_cq_value_t	*cqv;
 
 		if (instance->query_type != type)
 			continue;
 
-		if (ZBX_VMWARE_CQ_NEW != instance->state && now - instance->last_pooled > SEC_PER_DAY)
+		if (0 == (instance->state & ZBX_VMWARE_CQ_NEW) && now - instance->last_pooled > SEC_PER_DAY)
 		{
 			vmware_shared_cust_query_clean(instance);
 			zbx_hashset_iter_remove(&iter);
@@ -7492,16 +8200,21 @@ static void	vmware_service_cust_query_prep(zbx_hashset_t *cust_queries, const zb
 		if (0 != (instance->state & ZBX_VMWARE_CQ_PAUSED))
 			continue;
 
-		if (ZBX_VMWARE_CQ_NEW != instance->state &&
+		if (0 == (instance->state & ZBX_VMWARE_CQ_NEW) &&
 				now - instance->last_pooled > 2 * ZBX_VMWARE_CACHE_UPDATE_PERIOD)
 		{
 			instance->state |= ZBX_VMWARE_CQ_PAUSED;
 			continue;
 		}
 
-		cqv.instance = instance;
+		cqv = (zbx_vmware_cq_value_t *)zbx_malloc(NULL, sizeof(zbx_vmware_cq_value_t));
+		cqv->status = ZBX_VMWARE_CQV_EMPTY;
+		cqv->instance = instance;
+		cqv->response = NULL;
 		zbx_vector_cq_value_append(cq_values, cqv);
 	}
+
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s() cq_values:%d", __func__, cq_values->values_num);
 }
 
 /******************************************************************************
@@ -7532,7 +8245,7 @@ static void	vmware_service_dvswitch_load(CURL *easyhandle, zbx_vector_cq_value_t
 
 	for (i = 0; i < cq_values->values_num; i++)
 	{
-		zbx_vmware_cq_value_t	*cqv = &cq_values->values[i];
+		zbx_vmware_cq_value_t	*cqv = cq_values->values[i];
 		xmlNode			*node;
 
 		criteria[0] = '\0';
@@ -7598,36 +8311,47 @@ static void	vmware_service_dvswitch_load(CURL *easyhandle, zbx_vector_cq_value_t
  *                                                                            *
  * Parameters: fn_parent - [IN] parent function name                          *
  *             xdoc      - [IN] the xml document                              *
- *             cqv       - [IN/OUT] the custom query entry                    *
+ *             cqvs      - [IN/OUT] the custom query entries                  *
  *                                                                            *
  ******************************************************************************/
-static void	vmware_service_cq_prop_value(const char *fn_parent, xmlDoc *xdoc, zbx_vmware_cq_value_t *cqv)
+static void	vmware_service_cq_prop_value(const char *fn_parent, xmlDoc *xdoc, zbx_vector_cq_value_t *cqvs)
 {
-	char	xpath[MAX_STRING_LEN];
-	xmlNode	*node;
-
-	zbx_snprintf(xpath, sizeof(xpath), ZBX_XPATH_PROP_NAME("%s"), cqv->instance->key);
+	int	i;
 
-	if (NULL == (node = zbx_xml_doc_get(xdoc, xpath)))
-	{
-		cqv->response = NULL;
-		cqv->status = ZBX_VMWARE_CQV_VALUE;
-	}
-	else if (NULL != node->xmlChildrenNode && XML_TEXT_NODE == node->xmlChildrenNode->type)
-	{
-		cqv->response = zbx_xml_node_read_value(xdoc, node, ".");
-		cqv->status = ZBX_VMWARE_CQV_VALUE;
-	}
-	else
+	for (i = 0; i < cqvs->values_num; i++)
 	{
-		cqv->response = zbx_strdup(NULL, "only scalar values can be returned.");
-		cqv->status = ZBX_VMWARE_CQV_ERROR;
-	}
+		char			xpath[MAX_STRING_LEN];
+		xmlNode			*node;
+		zbx_vmware_cq_value_t	*cqv = cqvs->values[i];
+
+		zbx_snprintf(xpath, sizeof(xpath), ZBX_XPATH_PROP_NAME("%s"), cqv->instance->key);
+
+		if (NULL == (node = zbx_xml_doc_get(xdoc, xpath)))
+		{
+			cqv->response = NULL;
+			cqv->status = ZBX_VMWARE_CQV_VALUE;
+		}
+		else if ('\0' != *cqv->instance->mode && 0 == strcmp(cqv->instance->mode, "json"))
+		{
+			zbx_xmlnode_to_json(node, &cqv->response);
+			cqv->status = ZBX_VMWARE_CQV_VALUE;
+		}
+		else if (NULL != node->xmlChildrenNode && XML_TEXT_NODE == node->xmlChildrenNode->type)
+		{
+			cqv->response = zbx_xml_node_read_value(xdoc, node, ".");
+			cqv->status = ZBX_VMWARE_CQV_VALUE;
+		}
+		else
+		{
+			cqv->response = zbx_strdup(NULL, "only scalar values can be returned.");
+			cqv->status = ZBX_VMWARE_CQV_ERROR;
+		}
 
-	zabbix_log(LOG_LEVEL_DEBUG, "%s() %s id:%s key:%s response length:%d node type:%d", fn_parent,
-			ZBX_VMWARE_CQV_ERROR == cqv->status ? "FAIL" : "SUCCEED", cqv->instance->id,
-			cqv->instance->key, NULL == cqv->response ? -1 : (int)strlen(cqv->response),
-			NULL != node && NULL != node->xmlChildrenNode ? (int)node->xmlChildrenNode->type : -1);
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() %s id:%s key:%s response length:%d node type:%d", fn_parent,
+				ZBX_VMWARE_CQV_ERROR == cqv->status ? "FAIL" : "SUCCEED", cqv->instance->id,
+				cqv->instance->key, NULL == cqv->response ? -1 : (int)strlen(cqv->response),
+				NULL != node && NULL != node->xmlChildrenNode ? (int)node->xmlChildrenNode->type : -1);
+	}
 }
 
 /******************************************************************************
